#!/bin/bash
#
# @(#)text-detection.sh				22 déc. 2013
#
# This file was automatically generated by Ariane.
# Ariane is part of the Pantheon Project.
#
# GREYC - ENSICAEN & University of Caen Basse-Normandie, France

IFS=$(echo -en "\n\b")

# Check argument line consistency.
if [ $# -ge 1 -a "$1" = "-h" -o $# -ne 1 ]
then
    echo "Usage: $0  input-file1"
    echo "  example: $0 text02.pan"
    exit
fi

#
# Region Detection
#
function macro5_20() {
    # arguments
    # Input data files
    ln -fs $1 data_24_0_0.tmp; shift

    prgb2gray '0.299' '0.587' '0.114' data_24_0_0.tmp data_24_4_0.tmp ; var24_4_0=`pstatus`
    pgaussianfiltering '0.5' data_24_4_0.tmp data_24_8_0.tmp ; var24_8_0=`pstatus`
    macro6_24 data_24_8_0.tmp data_24_6_0.tmp; var24_6_0=`pstatus`
    macro5_24 '4' data_24_6_0.tmp data_24_5_0.tmp; var24_5_0=`pstatus`
    macro3_24 '0.8' data_24_5_0.tmp data_24_3_0.tmp; var24_3_0=`pstatus`
    macro9_24 '1' data_24_3_0.tmp data_24_9_0.tmp; var24_9_0=`pstatus`
    macro7_24 '1' data_24_9_0.tmp data_24_7_0.tmp; var24_7_0=`pstatus`
    macro2_24 '1' data_24_7_0.tmp data_24_2_0.tmp; var24_2_0=`pstatus`
    plabeling '8' data_24_2_0.tmp data_24_10_0.tmp ; var24_10_0=`pstatus`
    ln -fs data_24_10_0.tmp $1; shift

    psetstatus ${var24_10_0}
}

#
# Directional Morphological Gradient
# Computes the vertical gradient
# Uses the morphological gradient: dilatation(image) - erosion(image)  
#
function macro6_24() {
    # arguments
    # Input data files
    ln -fs $1 data_28_0_0.tmp; shift

    plineardilatation '0' '0' '1' data_28_0_0.tmp data_28_4_0.tmp ; var28_4_0=`pstatus`
    plinearerosion '0' '0' '1' data_28_0_0.tmp data_28_5_0.tmp ; var28_5_0=`pstatus`
    pdif data_28_4_0.tmp data_28_5_0.tmp data_28_2_0.tmp ; var28_2_0=`pstatus`
    ln -fs data_28_2_0.tmp $1; shift

    psetstatus ${var28_2_0}
}

#
# Horizontal Closing
#
function macro5_24() {
    # arguments
    var27_0_0=$1; shift
    # Input data files
    ln -fs $1 data_27_0_0.tmp; shift

    plineardilatation '0' '0' ${var27_0_0} data_27_0_0.tmp data_27_2_0.tmp ; var27_2_0=`pstatus`
    plinearerosion '0' '0' ${var27_0_0} data_27_2_0.tmp data_27_3_0.tmp ; var27_3_0=`pstatus`
    ln -fs data_27_3_0.tmp $1; shift

    psetstatus ${var27_3_0}
}

#
# Thresholding
# Detects areas that potentially contain text.
# Uses hysteresis thresholding between the high threshold k obtained by variance
# and the low threshold obtain as : u + a*(k-u) where a is a parameter and u the mean of the non text class.
#
function macro3_24() {
    # arguments
    var26_0_0=$1; shift
    # Input data files
    ln -fs $1 data_26_0_0.tmp; shift

    pvariancebinarization data_26_0_0.tmp data_26_2_0.tmp ; var26_2_0=`pstatus`
    pinverse data_26_2_0.tmp data_26_6_0.tmp ; var26_6_0=`pstatus`
    pmask data_26_0_0.tmp data_26_6_0.tmp data_26_5_0.tmp ; var26_5_0=`pstatus`
    pmeanvalue data_26_5_0.tmp data_26_9_0.tmp ; var26_9_0=`pstatus`
    var26_8_0=$(echo "${var26_9_0}+${var26_0_0}*(${var26_2_0}-${var26_9_0})"|bc -l);
    pbinarization ${var26_8_0} '1e30' data_26_0_0.tmp data_26_3_0.tmp ; var26_3_0=`pstatus`
    pgeodesicdilatation '1' '1' '-1' data_26_2_0.tmp data_26_3_0.tmp data_26_4_0.tmp ; var26_4_0=`pstatus`
    ln -fs data_26_4_0.tmp $1; shift

    psetstatus ${var26_4_0}
}

#
# VerticalOpening
# Removes small horizontal bridges between text components
#
function macro9_24() {
    # arguments
    var30_0_0=$1; shift
    # Input data files
    ln -fs $1 data_30_0_0.tmp; shift

    plinearerosion '90' '0' ${var30_0_0} data_30_0_0.tmp data_30_3_0.tmp ; var30_3_0=`pstatus`
    plineardilatation '90' '0' ${var30_0_0} data_30_3_0.tmp data_30_4_0.tmp ; var30_4_0=`pstatus`
    ln -fs data_30_4_0.tmp $1; shift

    psetstatus ${var30_4_0}
}

#
# VerticalOpening
# Removes small vertical bridges between text components
#
function macro7_24() {
    # arguments
    var29_0_0=$1; shift
    # Input data files
    ln -fs $1 data_29_0_0.tmp; shift

    plinearerosion '0' '0' ${var29_0_0} data_29_0_0.tmp data_29_4_0.tmp ; var29_4_0=`pstatus`
    plineardilatation '0' '0' ${var29_0_0} data_29_4_0.tmp data_29_3_0.tmp ; var29_3_0=`pstatus`
    ln -fs data_29_3_0.tmp $1; shift

    psetstatus ${var29_3_0}
}

#
# Closing
# Closes small holes.
# Morpological closing = erosion(dilation(image))
#
function macro2_24() {
    # arguments
    var25_0_0=$1; shift
    # Input data files
    ln -fs $1 data_25_0_0.tmp; shift

    pdilatation '0' ${var25_0_0} data_25_0_0.tmp data_25_2_0.tmp ; var25_2_0=`pstatus`
    perosion '0' ${var25_0_0} data_25_2_0.tmp data_25_3_0.tmp ; var25_3_0=`pstatus`
    ln -fs data_25_3_0.tmp $1; shift

    psetstatus ${var25_3_0}
}

#
# Eliminate Spurious Regions
# Eliminate too small regions (heigh and width)
#
function macro4_20() {
    # arguments
    var23_0_0=$1; shift
    var23_0_1=$1; shift
    # Input data files
    ln -fs $1 data_23_0_0.tmp; shift

    plinearerosion '0' '0' ${var23_0_0} data_23_0_0.tmp data_23_5_0.tmp ; var23_5_0=`pstatus`
    pgeodesicdilatation '0' '1' '-1' data_23_5_0.tmp data_23_0_0.tmp data_23_3_0.tmp ; var23_3_0=`pstatus`
    plinearerosion '90' '0' ${var23_0_1} data_23_3_0.tmp data_23_6_0.tmp ; var23_6_0=`pstatus`
    pgeodesicdilatation '0' '1' '-1' data_23_6_0.tmp data_23_3_0.tmp data_23_4_0.tmp ; var23_4_0=`pstatus`
    ln -fs data_23_4_0.tmp $1; shift

    psetstatus ${var23_4_0}
}

#
# Location
#
function macro3_20() {
    # arguments
    # Input data files
    ln -fs $1 data_22_0_0.tmp; shift

    pboundingbox data_22_0_0.tmp data_22_2_0.tmp ; var22_2_0=`pstatus`
    ln -fs data_22_2_0.tmp $1; shift

    psetstatus ${var22_2_0}
}

#
# DisplayResult
# Superposition of the result on the input image.
# The bounding boxes are drawn on the red channel.
#
function macro2_20() {
    # arguments
    # Input data files
    ln -fs $1 data_21_0_0.tmp; shift
    ln -fs $1 data_21_0_1.tmp; shift

    pboundary '8' data_21_0_1.tmp data_21_2_0.tmp ; var21_2_0=`pstatus`
    psuperimposition '1' data_21_0_0.tmp data_21_2_0.tmp data_21_4_0.tmp ; var21_4_0=`pstatus`
    ln -fs data_21_4_0.tmp $1; shift

    psetstatus ${var21_4_0}
}

#
# The main program
#
function main() {
    rm -f data?*.tmp
    ln -sf $1 data_1_7_0.tmp; shift
    macro5_20 data_1_7_0.tmp data_1_5_0.tmp; var1_5_0=`pstatus`
    macro4_20 '9' '4' data_1_5_0.tmp data_1_4_0.tmp; var1_4_0=`pstatus`
    macro3_20 data_1_4_0.tmp data_1_3_0.tmp; var1_3_0=`pstatus`
    macro2_20 data_1_7_0.tmp data_1_3_0.tmp data_1_2_0.tmp; var1_2_0=`pstatus`
    pvisu data_1_2_0.tmp
    ln -sf data_1_2_0.tmp data_1_6_0.tmp;
}

main $*
